#ifndef XMALLOC_H
#define XMALLOC_H

#include <stdio.h>
#include <stdlib.h>

/* 関数プロトタイプ */
static void * xmalloc(const size_t size);
static inline void * xmalloc_inline(const size_t size);

/*******************************************************************************
 * mallocのラッパー関数
*******************************************************************************/
static void * xmalloc(const size_t size)
{
	void *p = malloc(size);

	if(!p)
	{
		perror("malloc");
		exit(EXIT_FAILURE);
	}

	return p;
}

/*******************************************************************************
 * 1ファイル1グローバル関数にしてたんだけど、ここだけ例外。
*******************************************************************************/
static inline void * xmalloc_inline(const size_t size)
{
	void *p = malloc(size);

	if(!p)
	{
		perror("malloc");
		exit(EXIT_FAILURE);
	}

	return p;
}

#endif
